#!/bin/bash
#
# Connections manager script
#
let CON_COUNT=0 # define counting variable
for con_name in $(nmcli -t connection show | cut -f1 -d':' | grep -v "ll")
do
    echo "--$con_name--"
    awk -F $'\t' -v i="$CON_COUNT" 'BEGIN{
        delete ipv4_method;
        delete ipv6_method;
        delete ipv4_addresses;
        delete ipv6_addresses;
        delete if_name;
        delete con_name;
        delete ipv4_gateway;
        delete ipv6_gateway;
        }
        {
        if ($1 == "ipv4.method") ipv4_method[i]=$2;
        else if ($1 == "ipv6.method") ipv6_method[i]=$2;
        else if ($1 == "ipv4.addresses") ipv4_addresses[i]=$2;
        else if ($1 == "ipv6.addresses") ipv6_addresses[i]=$2;
        else if ($1 == "connection.interface-name") if_name[i]=$2;
        else if ($1 == "connection.id") con_name[i]=$2;
        else if ($1 == "ipv4.gateway") ipv4_gateway[i]=$2;
        else if ($1 == "ipv6.gateway") ipv6_gateway[i]=$2;
        }
        END{
            printf " INTERFACE_NAME[%d]=%s CONNECTION_NAME[%d]=%s IPV4_METHOD[%d]=%s IPV6_METHOD[%d]=%s",i,if_name[i],i,con_name[i],i,ipv4_method[i],i,ipv6_method[i];

            if (i in ipv4_addresses && ipv4_addresses[i] != "")
                printf " IPV4_ADDRESSES[%d]=%s",i,ipv4_addresses[i];
            else
                printf " IPV4_ADDRESSES[%d]=--",i;

            if (i in ipv6_addresses && ipv6_addresses[i] != "")
                printf " IPV6_ADDRESSES[%d]=%s",i,ipv6_addresses[i];
            else
                printf " IPV6_ADDRESSES[%d]=--",i;

            if (i in ipv4_gateway && ipv4_gateway[i] != "")
                printf " IPV4_GATEWAY[%d]=%s",i,ipv4_gateway[i];
            else
                printf " IPV4_GATEWAY[%d]=--",i;

            if (i in ipv6_gateway && ipv6_gateway[i] != "")
                printf " IPV6_GATEWAY[%d]=%s",i,ipv6_gateway[i];
            else
                printf " IPV6_GATEWAY[%d]=--",i;

        }' < <(nmcli -t -f connection.interface-name,connection.id,ipv4.method,ipv4.addresses,ipv4.gateway,ipv6.method,ipv6.addresses,ipv6.gateway connection show "$con_name" | sed 's/:/\t/')
        echo "  --$CON_COUNT--------------------------------  "
        let CON_COUNT+=1
done

#nmcli -t -f connection.interface-name,connection.id,ipv4.method,ipv4.addresses,ipv4.gateway,ipv6.method,ipv6.addresses,ipv6.gateway connection show Con2




awk -F $'\t' 'BEGIN{
    count=0;
    delete device;
    delete type;
    delete hwaddr;
    delete carrier;
    delete connection;
    delete ipv4;
    delete ipv4_count;
    delete ipv4_gw;
    delete ipv4_dhcpll_address;
    delete ipv6;
    delete ipv6_count;
    delete ipv6_gw;
    }
    {
    if ($1 == "GENERAL.DEVICE") {count++; device[count]=$2;}
    else if ($1 == "GENERAL.TYPE") type[count]=$2;
    else if ($1 == "GENERAL.HWADDR") hwaddr[count]=$2;
    else if ($1 == "WIRED-PROPERTIES.CARRIER") carrier[count]=$2;
    else if ($1 == "GENERAL.CONNECTION") connection[count]=$2;
    else if (substr($1,1,12) == "IP4.ADDRESS[")
    {
        ipv4_count[count]=substr($1,13,1);
        if (ipv4_count[count] == 1)
        {
            ipv4[count]=$2;
            if (substr(connection[count],5,2) == "ll")
            {
                sub(/\/.*/, "", $2);
                ipv4_dhcpll_address[count]=$2;
            }
        }
        else ipv4[count]=ipv4[count] "," $2;
    }
    else if ($1 == "IP4.GATEWAY") ipv4_gw[count]=$2;
    else if (substr($1,1,12) == "IP6.ADDRESS[")
    {
        ipv6_count[count]=substr($1,13,1);
        if (ipv6_count[count] == 1) ipv6[count]=$2;
        else ipv6[count]=ipv6[count] "," $2;
    }
    else if ($1 == "IP6.GATEWAY") ipv6_gw[count]=$2;
    }
    END{

    for (i = 1; i <= count; i++)
    {
        if (type[i] == "ethernet")
        {
            printf " DEV[%d]=%s HWADDR[%d]=%s CARRIER[%d]=%s",i,device[i],i,hwaddr[i],i,carrier[i];

            if (i in connection && connection[i] != "")
                printf " CONNECTION[%d]=\"%s\"",i,connection[i];
            else
                printf " CONNECTION[%d]=\"--\"",i;

            if (i in ipv4_count && ipv4_count[i] != "")
                printf " IPV4_COUNT[%d]=%s",i,ipv4_count[i];
            else
                printf " IPV4_COUNT[%d]=--",i;

            if (i in ipv4 && ipv4[i] != "")
                printf " IPV4[%d]=%s",i,ipv4[i];
            else
                printf " IPV4[%d]=--",i;

            if (i in ipv4_gw && ipv4_gw[i] != "")
                printf " IPV4_GW[%d]=%s",i,ipv4_gw[i];
            else
                printf " IPV4_GW[%d]=--",i;

            if (i in ipv4_dhcpll_address && ipv4_dhcpll_address[i] != "")
                printf " IPV4_DHCPLL_ADDRESS[%d]=%s",i,ipv4_dhcpll_address[i];
            else
                printf " IPV4_DHCPLL_ADDRESS[%d]=--",i;


            if (i in ipv6_count && ipv6_count[i] != "")
                printf " IPV6_COUNT[%d]=%s",i,ipv6_count[i];
            else
                printf " IPV6_COUNT[%d]=--",i;

            if (i in ipv6 && ipv6[i] != "")
                printf " IPV6[%d]=%s",i,ipv6[i];
            else
                printf " IPV6[%d]=--",i;

            if (i in ipv6_gw && ipv6_gw[i] != "")
                printf " IPV6_GW[%d]=%s",i,ipv6_gw[i];
            else
                printf " IPV6_GW[%d]=--",i;

        }
    }
    }' < <(nmcli -t device show | sed 's/:/\t/')

echo "  --------------------------------------------------  "

eval $(awk -F $'\t' 'BEGIN{
    count=0;
    delete device;
    delete type;
    delete hwaddr;
    delete carrier;
    delete connection;
    delete ipv4;
    delete ipv4_count;
    delete ipv4_gw;
    delete ipv4_dhcpll_address;
    delete ipv6;
    delete ipv6_count;
    delete ipv6_gw;
    }
    {
    if ($1 == "GENERAL.DEVICE") {count++; device[count]=$2;}
    else if ($1 == "GENERAL.TYPE") type[count]=$2;
    else if ($1 == "GENERAL.HWADDR") hwaddr[count]=$2;
    else if ($1 == "WIRED-PROPERTIES.CARRIER") carrier[count]=$2;
    else if ($1 == "GENERAL.CONNECTION") connection[count]=$2;
    else if (substr($1,1,12) == "IP4.ADDRESS[")
    {
        ipv4_count[count]=substr($1,13,1);
        if (ipv4_count[count] == 1)
        {
            ipv4[count]=$2;
            if (substr(connection[count],5,2) == "ll")
            {
                sub(/\/.*/, "", $2);
                ipv4_dhcpll_address[count]=$2;
            }
        }
        else ipv4[count]=ipv4[count] "," $2;
    }
    else if ($1 == "IP4.GATEWAY") ipv4_gw[count]=$2;
    else if (substr($1,1,12) == "IP6.ADDRESS[")
    {
        ipv6_count[count]=substr($1,13,1);
        if (ipv6_count[count] == 1) ipv6[count]=$2;
        else ipv6[count]=ipv6[count] "," $2;
    }
    else if ($1 == "IP6.GATEWAY") ipv6_gw[count]=$2;
    }
    END{

    for (i = 1; i <= count; i++)
    {
        if (type[i] == "ethernet")
        {
            printf " DEV[%d]=%s HWADDR[%d]=%s CARRIER[%d]=%s",i,device[i],i,hwaddr[i],i,carrier[i];

            if (i in connection && connection[i] != "")
                printf " CONNECTION[%d]=\"%s\"",i,connection[i];
            else
                printf " CONNECTION[%d]=\"--\"",i;

            if (i in ipv4_count && ipv4_count[i] != "")
                printf " IPV4_COUNT[%d]=%s",i,ipv4_count[i];
            else
                printf " IPV4_COUNT[%d]=--",i;

            if (i in ipv4 && ipv4[i] != "")
                printf " IPV4[%d]=%s",i,ipv4[i];
            else
                printf " IPV4[%d]=--",i;

            if (i in ipv4_gw && ipv4_gw[i] != "")
                printf " IPV4_GW[%d]=%s",i,ipv4_gw[i];
            else
                printf " IPV4_GW[%d]=--",i;

            if (i in ipv4_dhcpll_address && ipv4_dhcpll_address[i] != "")
                printf " IPV4_DHCPLL_ADDRESS[%d]=%s",i,ipv4_dhcpll_address[i];
            else
                printf " IPV4_DHCPLL_ADDRESS[%d]=--",i;


            if (i in ipv6_count && ipv6_count[i] != "")
                printf " IPV6_COUNT[%d]=%s",i,ipv6_count[i];
            else
                printf " IPV6_COUNT[%d]=--",i;

            if (i in ipv6 && ipv6[i] != "")
                printf " IPV6[%d]=%s",i,ipv6[i];
            else
                printf " IPV6[%d]=--",i;

            if (i in ipv6_gw && ipv6_gw[i] != "")
                printf " IPV6_GW[%d]=%s",i,ipv6_gw[i];
            else
                printf " IPV6_GW[%d]=--",i;

        }
    }
    }' < <(nmcli -t device show | sed 's/:/\t/') )

    for i in "${!CONNECTION[@]}"
    do
        CONNECTION[$i]="${CONNECTION[$i]%"ll"}"

        if [ "${CONNECTION[$i]}" == "--" ]
        then
            declare IPV4_METHOD[$i]=manual IPV6_METHOD[$i]=auto IPV4_DHCP_ADDRESS[$i]=-- IPV6_DHCP_ADDRESS[$i]=--
        else

            #if [ -z "$(grep "${CARRIER[$i]}" "/tmp/${CONNECTION[$i]}.status")" ]
            #then
            #    LOCK_FILE_CON=/tmp/${CONNECTION[$i]}.changing

            #    if [ ! -f "$LOCK_FILE_CON" ]
            #    then
            #        echo $$ > "$LOCK_FILE_CON"

            #        /etc/init.d/S46system-config updateinterfaces ${DEV[$i]} >/tmp/${CONNECTION[$i]}.log 2>/tmp/${CONNECTION[$i]}.err

            #        echo "${CARRIER[$i]}" > "/tmp/${CONNECTION[$i]}.status"
            #        rm -f "$LOCK_FILE_CON"
            #    fi
            #fi

            declare $(awk -F $'\t' -v i="$i" 'BEGIN{
            delete ipv4_method;
            delete ipv6_method;
            delete ipv4_dhcp_address;
            delete ipv6_dhcp_address;
            }
            {
            if ($1 == "ipv4.method") ipv4_method[i]=$2;
            else if ($1 == "ipv6.method") ipv6_method[i]=$2;

            else if (substr($1,1,12) == "DHCP4.OPTION") {
                    if (substr($2,1,13) == "ip_address = ") {
                        ipv4_dhcp_address[i]=substr($2,14);
                    }
                }
            else if (substr($1,1,12) == "DHCP6.OPTION") {
                    if (substr($2,1,13) == "ip_address = ") {
                        ipv6_dhcp_address[i]=substr($2,14);
                    }
                }
            }
            END{
                printf " IPV4_METHOD[%d]=%s IPV6_METHOD[%d]=%s",i,ipv4_method[i],i,ipv6_method[i];

                if (i in ipv4_dhcp_address && ipv4_dhcp_address[i] != "")
                    printf " IPV4_DHCP_ADDRESS[%d]=%s",i,ipv4_dhcp_address[i];
                else
                    printf " IPV4_DHCP_ADDRESS[%d]=--",i;

                if (i in ipv6_dhcp_address && ipv6_dhcp_address[i] != "")
                    printf " IPV6_DHCP_ADDRESS[%d]=%s",i,ipv6_dhcp_address[i];
                else
                    printf " IPV6_DHCP_ADDRESS[%d]=--",i;
            }' < <(nmcli -t -f ipv4.method,DHCP4,ipv6.method,DHCP6 connection show "${CONNECTION[$i]}" | sed 's/:/\t/') )
        fi

        declare $(awk -v i="$i" '{
        if ($1 == "Speed:") {
            sub (/Mb\/s/,"",$2);
            sub (/Unknown!/,"0",$2);
            speed[i]=$2;
        }
        }
        END{
            printf " SPEED[%d]=%s",i,speed[i];
        }' < <(ethtool ${DEV[$i]} 2>/dev/null) )

        [ "${IPV4_DHCPLL_ADDRESS[$i]}" != "--" ] && IPV4_DHCP_ADDRESS[$i]=${IPV4_DHCPLL_ADDRESS[$i]}

        echo "${CONNECTION[$i]},${DEV[$i]},${HWADDR[$i]},${SPEED[$i]},${CARRIER[$i]},${IPV4_METHOD[$i]},${IPV4_DHCP_ADDRESS[$i]},${IPV4_COUNT[$i]},${IPV4[$i]},${IPV4_GW[$i]},${IPV6_METHOD[$i]},${IPV6_DHCP_ADDRESS[$i]},${IPV6_COUNT[$i]},${IPV6[$i]},${IPV6_GW[$i]}"

        #echo "${CONNECTION[$i]},${DEV[$i]},${HWADDR[$i]},${SPEED[$i]},${CARRIER[$i]},${IPV4_METHOD[$i]},${IPV4_1[$i]},${IPV4_2[$i]},${IPV4_GW[$i]},${IPV6_METHOD[$i]},${IPV6_1[$i]},${IPV6_2[$i]},${IPV6_GW[$i]}"

        #echo "${CONNECTION[$i]},${DEV[$i]},${HWADDR[$i]},${SPEED[$i]},${CARRIER[$i]},${IPV4_METHOD[$i]},${IPV4_1[$i]},${IPV4_2[$i]},${IPV4_3[$i]},${IPV4_GW[$i]},${IPV6_METHOD[$i]},${IPV6_1[$i]},${IPV6_2[$i]},${IPV6_3[$i]},${IPV6_GW[$i]},test"

        #echo -n "${CONNECTION[$i]},${DEV[$i]},${HWADDR[$i]},${SPEED[$i]},${CARRIER[$i]},${IPV4_METHOD[$i]}," #${IPV4_1[$i]},${IPV4_2[$i]},${IPV4_GW[$i]},${IPV6_METHOD[$i]},${IPV6_1[$i]},${IPV6_2[$i]},${IPV6_GW[$i]}"

        #IPV4_ADDRESSES has only static IPs; IPV4_[123] have static *and* DHCP IPs. Now we should found DHCP address and print it at the last position

        #IPV4_ADDRESSES[$i]="${IPV4_ADDRESSES[$i]//-/x}"

        #echo "${IPV4_COUNT[$i]},${IPV4[$i]},${IPV4_GW[$i]},${IPV4_DHCP_ADDRESS[$i]},${IPV6_METHOD[$i]},${IPV6_COUNT[$i]},${IPV6[$i]},${IPV6_GW[$i]},${IPV6_DHCP_ADDRESS[$i]}"

        #if $(echo "${IPV4_ADDRESSES[$i]}" | grep -q -v -- "${IPV4_1[$i]}")
        #then
        #    echo -n "${IPV4_2[$i]},${IPV4_3[$i]},${IPV4_1[$i]},${IPV4_GW[$i]},${IPV6_METHOD[$i]},"
        #elif $(echo "${IPV4_ADDRESSES[$i]}" | grep -q -v -- "${IPV4_2[$i]}")
        #then
        #    echo -n "${IPV4_1[$i]},${IPV4_3[$i]},${IPV4_2[$i]},${IPV4_GW[$i]},${IPV6_METHOD[$i]},"
        #elif $(echo "${IPV4_ADDRESSES[$i]}" | grep -q -v -- "${IPV4_3[$i]}")
        #then
        #    echo -n "${IPV4_1[$i]},${IPV4_2[$i]},${IPV4_3[$i]},${IPV4_GW[$i]},${IPV6_METHOD[$i]},"
        #fi

        #IPV6_ADDRESSES[$i]="${IPV6_ADDRESSES[$i]//-/x}"

        #if $(echo "${IPV6_ADDRESSES[$i]}" | grep -q -v -- "${IPV6_1[$i]}")
        #then
        #    echo "${IPV6_2[$i]},${IPV6_3[$i]},${IPV6_1[$i]},${IPV6_GW[$i]}"
        #elif $(echo "${IPV6_ADDRESSES[$i]}" | grep -q -v -- "${IPV6_2[$i]}")
        #then
        #    echo "${IPV6_1[$i]},${IPV6_3[$i]},${IPV6_2[$i]},${IPV6_GW[$i]}"
        #elif $(echo "${IPV6_ADDRESSES[$i]}" | grep -q -v -- "${IPV6_3[$i]}")
        #then
        #    echo "${IPV6_1[$i]},${IPV6_2[$i]},${IPV6_3[$i]},${IPV6_GW[$i]}"
        #fi

    done


nmcli -t -f connection.interface-name,connection.id,ipv4.method,ipv4.addresses,ipv4.gateway,ipv6.method,ipv6.addresses,ipv6.gateway connection show Con2
